// CurrencyFormatStruct.cpp
// Copyright  January 2004, Mihai Nita

#include "CurrencyFormatStruct.h"

#define	DIM(a)	(sizeof(a)/sizeof(a[0]))

int CCurrencyFormatStruct::GetDefaultFormat( LCID lcid )
{
    TCHAR	buff[100]; // huge, but just in case
    int	nRez = 1;

    memset( &struCurrencyFormat, 0, sizeof(struCurrencyFormat) );

    // Not using LOCALE_RETURN_NUMBER, is not available for Win 95.
    // I want to be compatible all the way back (I wonder why :-)
    // And in fact the ugliest one is LOCALE_SGROUPING, which does not support LOCALE_RETURN_NUMBER

    nRez &= GetLocaleInfo( lcid, LOCALE_ICURRDIGITS, buff, DIM(buff) ); // max 3
    struCurrencyFormat.NumDigits = _tcstoul( buff, NULL, 0 );

    nRez &= GetLocaleInfo( lcid, LOCALE_ILZERO, buff, DIM(buff) ); // max 2
    struCurrencyFormat.LeadingZero = _tcstoul( buff, NULL, 0 );

    nRez &= GetLocaleInfo( lcid, LOCALE_SMONDECIMALSEP, decimalSep, DIM(decimalSep) ); // max 4
    struCurrencyFormat.lpDecimalSep = decimalSep;

    nRez &= GetLocaleInfo( lcid, LOCALE_SMONTHOUSANDSEP, thousandSep, DIM(thousandSep) ); // max 4
    struCurrencyFormat.lpThousandSep = thousandSep;

    nRez &= GetLocaleInfo( lcid, LOCALE_SCURRENCY, currencySymbol, DIM(currencySymbol) ); // max 6
    struCurrencyFormat.lpCurrencySymbol = currencySymbol;

    nRez &= GetLocaleInfo( lcid, LOCALE_INEGCURR, buff, DIM(buff) ); // max 3
    struCurrencyFormat.NegativeOrder = _tcstoul( buff, NULL, 0 );

    nRez &= GetLocaleInfo( lcid, LOCALE_ICURRENCY, buff, DIM(buff) ); // max 3
    struCurrencyFormat.PositiveOrder = _tcstoul( buff, NULL, 0 );

    nRez &= GetLocaleInfo( lcid, LOCALE_SMONGROUPING, buff, DIM(buff) ); // max 4
    // Now the ugly part. Have to convert from something like string "3;2;0" to int 32
    TCHAR	*parseGrpS = buff;
    while( *parseGrpS ) {
        if( (*parseGrpS >= _T('1')) && (*parseGrpS <= _T('9')) )
            struCurrencyFormat.Grouping = struCurrencyFormat.Grouping * 10 + (*parseGrpS-_T('0'));
        if( (*parseGrpS != _T('0')) && !parseGrpS[1] )
			struCurrencyFormat.Grouping *= 10;
        parseGrpS++;
    }
    return nRez;
}
