// NumberFormatStruct.cpp
// Copyright  January 2004, Mihai Nita

#include "NumberFormatStruct.h"

#define	DIM(a)	(sizeof(a)/sizeof(a[0]))

int CNumberFormatStruct::GetDefaultFormat( LCID lcid )
{
    TCHAR	buff[100]; // huge, but just in case
    int	nRez = 1;

    memset( &struNumberFormat, 0, sizeof(struNumberFormat) );

    // Not using LOCALE_RETURN_NUMBER, is not available for Win 95.
    // I want to be compatible all the way back (I wonder why :-)
    // And in fact the ugliest one is LOCALE_SGROUPING, which does not support LOCALE_RETURN_NUMBER

    nRez &= GetLocaleInfo( lcid, LOCALE_IDIGITS, buff, DIM(buff) ); // max 2
    struNumberFormat.NumDigits = _tcstoul( buff, NULL, 0 );

    nRez &= GetLocaleInfo( lcid, LOCALE_ILZERO, buff, DIM(buff) ); // max 2
    struNumberFormat.LeadingZero = _tcstoul( buff, NULL, 0 );

    nRez &= GetLocaleInfo( lcid, LOCALE_SDECIMAL, decimalSep, DIM(decimalSep) ); // max 4
    struNumberFormat.lpDecimalSep = decimalSep;

    nRez &= GetLocaleInfo( lcid, LOCALE_STHOUSAND, thousandSep, DIM(thousandSep) ); // max 4
    struNumberFormat.lpThousandSep = thousandSep;

    nRez &= GetLocaleInfo( lcid, LOCALE_INEGNUMBER, buff, DIM(buff) ); // max 2
    struNumberFormat.NegativeOrder = _tcstoul( buff, NULL, 0 );

    nRez &= GetLocaleInfo( lcid, LOCALE_SGROUPING, buff, DIM(buff) ); //max undocumented
    // Now the ugly part. Have to convert from something like string "3;2;0" to int 32
    TCHAR	*parseGrpS = buff;
    while( *parseGrpS ) {
        if( (*parseGrpS >= _T('1')) && (*parseGrpS <= _T('9')) )
            struNumberFormat.Grouping = struNumberFormat.Grouping * 10 + (*parseGrpS-_T('0'));
        if( (*parseGrpS != _T('0')) && !parseGrpS[1] )
			struNumberFormat.Grouping *= 10;
        parseGrpS++;
    }

    return nRez;
}
