#include <stdio.h>
#include <tchar.h>

#include "NumberFormatStruct.h"
#include "CurrencyFormatStruct.h"

#define	DIM(a)	(sizeof(a)/sizeof(a[0]))

BOOL CALLBACK EnumLocalesProc( LPTSTR lpLocaleString )
{
	TCHAR buff[100];
	TCHAR out1[100], out2[100];

	UINT lcid = _tcstoul( lpLocaleString, NULL, 16 );
	_tprintf( _T("%s: 0x%x (%d)\n"), lpLocaleString, lcid, lcid );

	CNumberFormatStruct nfs(lcid);

	_tprintf( _T("  NumberFormat\n") );
    GetLocaleInfo( lcid, LOCALE_SGROUPING, buff, DIM(buff) );
	_tprintf( _T("    '%s' => %d\n"), buff, nfs.struNumberFormat.Grouping );

	GetNumberFormat( lcid, 0, _T("123456789.54321"), NULL, out1, DIM(out1) );
	_tprintf( _T("    '%s'\n"), out1 );

	GetNumberFormat( lcid, 0, _T("123456789.54321"), &nfs.struNumberFormat, out2, DIM(out2) );
	_tprintf( _T("    '%s'\n"), out2 );

	if( _tcscmp( out1, out2 ) )
		_tprintf( _T("    !!! ERROR !!!") );


	_tprintf( _T("  CurrencyFormat\n") );
	CCurrencyFormatStruct cfs(lcid);
    GetLocaleInfo( lcid, LOCALE_SMONGROUPING, buff, DIM(buff) );
	_tprintf( _T("    '%s' => %d\n"), buff, cfs.struCurrencyFormat.Grouping );

	GetCurrencyFormat( lcid, 0, _T("123456789.54321"), NULL, out1, DIM(out1) );
	_tprintf( _T("    '%s'\n"), out1 );

	GetCurrencyFormat( lcid, 0, _T("123456789.54321"), &cfs.struCurrencyFormat, out2, DIM(out2) );
	_tprintf( _T("    '%s'\n"), out2 );

	if( _tcscmp( out1, out2 ) )
		_tprintf( _T("    !!! ERROR !!!") );


	_tprintf( _T("\n") );

	return TRUE;
}

int main( void )
{
	EnumSystemLocales( EnumLocalesProc, LCID_INSTALLED );

	return 0;
}
